Index: .bzrignore
===================================================================
--- .bzrignore	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ .bzrignore	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -33,5 +33,5 @@
 uspace/app/kill/kill
 uspace/app/killall/killall
-uspace/app/klog/klog
+uspace/app/kio/kio
 uspace/app/loc/loc
 uspace/app/logset/logset
@@ -82,5 +82,5 @@
 uspace/dist/app/kill
 uspace/dist/app/killall
-uspace/dist/app/klog
+uspace/dist/app/kio
 uspace/dist/app/loc
 uspace/dist/app/logset
@@ -279,2 +279,10 @@
 uspace/app/viewer/viewer
 uspace/dist/app/viewer
+uspace/app/hdisk/hdisk
+uspace/dist/app/hdisk
+uspace/app/untar/untar
+uspace/dist/app/untar
+uspace/lib/posix/redefs-hide-libc-symbols.list
+uspace/lib/posix/redefs-show-posix-symbols.list
+uspace/srv/klog/klog
+uspace/dist/srv/klog
Index: abi/include/abi/ipc/event.h
===================================================================
--- abi/include/abi/ipc/event.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ abi/include/abi/ipc/event.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -38,10 +38,12 @@
 /** Global events */
 typedef enum event_type {
-	/** New data available in kernel log */
-	EVENT_KLOG = 0,
+	/** New data available in kernel character buffer */
+	EVENT_KIO = 0,
 	/** Returning from kernel console to uspace */
 	EVENT_KCONSOLE,
 	/** A task/thread has faulted and will be terminated */
 	EVENT_FAULT,
+	/** New data available in kernel log */
+	EVENT_KLOG,
 	EVENT_END
 } event_type_t;
Index: abi/include/abi/kio.h
===================================================================
--- abi/include/abi/kio.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
+++ abi/include/abi/kio.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2012 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef ABI_KIO_H_
+#define ABI_KIO_H_
+
+enum {
+	KIO_UNKNOW,
+	KIO_WRITE,
+	KIO_UPDATE,
+	KIO_COMMAND
+};
+
+#endif
+
+/** @}
+ */
Index: abi/include/abi/klog.h
===================================================================
--- abi/include/abi/klog.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ abi/include/abi/klog.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jakub Jermar
+ * Copyright (c) 2014 Martin Sucha
  * All rights reserved.
  *
@@ -36,10 +36,8 @@
 #define ABI_KLOG_H_
 
-enum {
-	KLOG_UNKNOW,
+typedef enum {
 	KLOG_WRITE,
-	KLOG_UPDATE,
-	KLOG_COMMAND
-};
+	KLOG_READ
+} klog_operation_t;
 
 #endif
Index: abi/include/abi/log.h
===================================================================
--- abi/include/abi/log.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
+++ abi/include/abi/log.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2011 Vojtech Horky
+ * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2013 Martin Sucha
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genericlog
+ * @{
+ */
+/** @file
+ */
+
+#ifndef ABI_LOG_H_
+#define ABI_LOG_H_
+
+/** Log message level. */
+typedef enum {
+	/** Fatal error, program is not able to recover at all. */
+	LVL_FATAL,
+	/** Serious error but the program can recover from it. */
+	LVL_ERROR,
+	/** Easily recoverable problem. */
+	LVL_WARN,
+	/** Information message that ought to be printed by default. */
+	LVL_NOTE,
+	/** Debugging purpose message. */
+	LVL_DEBUG,
+	/** More detailed debugging message. */
+	LVL_DEBUG2,
+	
+	/** For checking range of values */
+	LVL_LIMIT
+} log_level_t;
+
+/* Who is the source of the message? */
+typedef enum {
+	LF_OTHER = 0,
+	LF_USPACE,
+	LF_ARCH
+} log_facility_t;
+
+#endif
+
+/** @}
+ */
Index: abi/include/abi/syscall.h
===================================================================
--- abi/include/abi/syscall.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ abi/include/abi/syscall.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -37,5 +37,5 @@
 
 typedef enum {
-	SYS_KLOG = 0,
+	SYS_KIO = 0,
 	SYS_TLS_SET = 1,  /* Hardcoded for AMD64, IA-32 (fibril.S in uspace) */
 	
@@ -99,4 +99,6 @@
 	SYS_DEBUG_ACTIVATE_CONSOLE,
 	
+	SYS_KLOG,
+	
 	SYSCALL_END
 } syscall_t;
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ boot/Makefile.common	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -96,5 +96,6 @@
 	$(USPACE_PATH)/srv/devman/devman \
 	$(USPACE_PATH)/srv/fs/locfs/locfs \
-	$(USPACE_PATH)/srv/hid/compositor/compositor
+	$(USPACE_PATH)/srv/hid/compositor/compositor \
+	$(USPACE_PATH)/srv/klog/klog
 
 RD_SRVS_NON_ESSENTIAL = \
@@ -161,5 +162,5 @@
 	$(USPACE_PATH)/app/bdsh/bdsh \
 	$(USPACE_PATH)/app/getterm/getterm \
-	$(USPACE_PATH)/app/klog/klog \
+	$(USPACE_PATH)/app/kio/kio \
 	$(USPACE_PATH)/app/vlaunch/vlaunch \
 	$(USPACE_PATH)/app/vterm/vterm
Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ boot/arch/arm32/Makefile.inc	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -43,4 +43,12 @@
 endif
 
+ifeq ($(MACHINE), raspberrypi)
+	BOOT_OUTPUT = image.boot
+	POST_OUTPUT = $(ROOT_PATH)/uImage.bin	
+	LADDR = 0x00008000
+	SADDR = 0x00008000
+	POSTBUILD = Makefile.uboot	     
+endif
+
 BFD_NAME = elf32-littlearm
 BFD_OUTPUT = $(BFD_NAME)
Index: boot/arch/arm32/include/arch.h
===================================================================
--- boot/arch/arm32/include/arch.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ boot/arch/arm32/include/arch.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -46,4 +46,6 @@
 #elif defined MACHINE_beaglebone
 #define BOOT_BASE       0x80000000
+#elif defined MACHINE_raspberrypi
+#define BOOT_BASE	0x00008000
 #else
 #define BOOT_BASE	0x00000000
Index: boot/arch/arm32/include/main.h
===================================================================
--- boot/arch/arm32/include/main.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ boot/arch/arm32/include/main.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -75,4 +75,24 @@
 #define ICP_SCONS_ADDR		0x16000000
 
+/** Raspberry PI serial console registers */
+#define BCM2835_UART0_BASE	0x20201000
+#define BCM2835_UART0_DR	(BCM2835_UART0_BASE + 0x00)
+#define BCM2835_UART0_FR	(BCM2835_UART0_BASE + 0x18)
+#define BCM2835_UART0_ILPR	(BCM2835_UART0_BASE + 0x20)
+#define BCM2835_UART0_IBRD	(BCM2835_UART0_BASE + 0x24)
+#define BCM2835_UART0_FBRD	(BCM2835_UART0_BASE + 0x28)
+#define BCM2835_UART0_LCRH	(BCM2835_UART0_BASE + 0x2C)
+#define BCM2835_UART0_CR	(BCM2835_UART0_BASE + 0x30)
+#define BCM2835_UART0_ICR	(BCM2835_UART0_BASE + 0x44)
+
+#define BCM2835_UART0_FR_TXFF	(1 << 5)
+#define BCM2835_UART0_LCRH_FEN	(1 << 4)
+#define BCM2835_UART0_LCRH_WL8	((1 << 5) | (1 << 6))
+#define BCM2835_UART0_CR_UARTEN	(1 << 0)
+#define BCM2835_UART0_CR_TXE	(1 << 8)
+#define BCM2835_UART0_CR_RXE	(1 << 9)
+
+
+
 extern void bootstrap(void);
 
Index: boot/arch/arm32/include/mm.h
===================================================================
--- boot/arch/arm32/include/mm.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ boot/arch/arm32/include/mm.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -68,4 +68,8 @@
 #define AM335x_RAM_END     0xC0000000
 
+/** Start of ram memory on BCM2835 */
+#define BCM2835_RAM_START   0
+/** End of ram memory on BCM2835 */
+#define BCM2835_RAM_END     0x20000000
 
 /* Page table level 0 entry - "section" format is used
Index: boot/arch/arm32/src/mm.c
===================================================================
--- boot/arch/arm32/src/mm.c	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ boot/arch/arm32/src/mm.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -116,4 +116,7 @@
 	if (address >= AM335x_RAM_START && address < AM335x_RAM_END)
 		return 1;
+#elif defined MACHINE_raspberrypi
+	if (address < BCM2835_RAM_END)
+		return 1;
 #endif
 	return address * 0;
Index: boot/arch/arm32/src/putchar.c
===================================================================
--- boot/arch/arm32/src/putchar.c	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ boot/arch/arm32/src/putchar.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -122,4 +122,46 @@
 #endif
 
+#ifdef MACHINE_raspberrypi
+
+static int raspi_init;
+
+static inline void write32(uint32_t addr, uint32_t data)
+{
+	*(volatile uint32_t *)(addr) = data;
+}
+
+static inline uint32_t read32(uint32_t addr)
+{
+	return *(volatile uint32_t *)(addr);
+}
+
+static void scons_init_raspi(void)
+{
+	write32(BCM2835_UART0_CR, 0x0);		/* Disable UART */
+	write32(BCM2835_UART0_ICR, 0x7f);	/* Clear interrupts */
+	write32(BCM2835_UART0_IBRD, 1);		/* Set integer baud rate */
+	write32(BCM2835_UART0_FBRD, 40);	/* Set fractional baud rate */
+	write32(BCM2835_UART0_LCRH,
+		BCM2835_UART0_LCRH_FEN |	/* Enable FIFOs */
+		BCM2835_UART0_LCRH_WL8);	/* Word length: 8 */
+	write32(BCM2835_UART0_CR,
+		BCM2835_UART0_CR_UARTEN |	/* Enable UART */
+		BCM2835_UART0_CR_TXE |		/* Enable TX */
+		BCM2835_UART0_CR_RXE);		/* Enable RX */
+}
+
+static void scons_sendb_raspi(uint8_t byte)
+{
+	if (!raspi_init) {
+		scons_init_raspi();
+		raspi_init = 1;
+	}
+
+	while (read32(BCM2835_UART0_FR) & BCM2835_UART0_FR_TXFF);
+
+	write32(BCM2835_UART0_DR, byte);
+}
+#endif
+
 /** Send a byte to the serial console.
  *
@@ -139,4 +181,7 @@
 #ifdef MACHINE_integratorcp
 	scons_sendb_icp(byte);
+#endif
+#ifdef MACHINE_raspberrypi
+	scons_sendb_raspi(byte);
 #endif
 }
Index: contrib/arch/HelenOS.adl
===================================================================
--- contrib/arch/HelenOS.adl	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ contrib/arch/HelenOS.adl	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -22,5 +22,5 @@
 	
 	/* Kernel log */
-	inst klog klog;
+	inst kio kio;
 	
 	[/uspace/lib/libc/bind%ns]
@@ -30,5 +30,5 @@
 	[/uspace/lib/libc/bind%vfs]
 	[/uspace/lib/libc/bind%console]
-	[/uspace/lib/libc/bind%klog]
+	[/uspace/lib/libc/bind%kio]
 	
 	bind ns:kbd to console:kbd;
@@ -58,4 +58,4 @@
 	bind console:sys_console to kernel:sys_console;
 	
-	bind klog:ns to ns:ns;
+	bind kio:ns to ns:ns;
 };
Index: contrib/arch/kernel/kernel.adl
===================================================================
--- contrib/arch/kernel/kernel.adl	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ contrib/arch/kernel/kernel.adl	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -3,9 +3,9 @@
  *****************************/
 
-interface sys_klog {
+interface sys_kio {
 		/* Print using kernel facility */
-		sysarg_t sys_klog(int fd, const void *buf, size_t size);
-	protocol:
-		?sys_klog*
+		sysarg_t sys_kio(int fd, const void *buf, size_t size);
+	protocol:
+		?sys_kio*
 };
 
@@ -251,5 +251,5 @@
 frame sys_console {
 	provides:
-		sys_klog sys_klog;
+		sys_kio sys_kio;
 		sys_console sys_console;
 };
@@ -316,5 +316,5 @@
 	inst sys_debug sys_debug;
 	
-	delegate sys_klog to sys_console:sys_klog;
+	delegate sys_kio to sys_console:sys_kio;
 	delegate sys_console to sys_console:sys_console;
 	delegate sys_tls to sys_proc:sys_tls;
Index: contrib/arch/uspace/app/kio/kio.adl
===================================================================
--- contrib/arch/uspace/app/kio/kio.adl	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
+++ contrib/arch/uspace/app/kio/kio.adl	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -0,0 +1,9 @@
+frame kio {
+	requires:
+		naming_service ns;
+		[/uspace/lib/libc/requires]
+	initialization:
+		!ns.ipc_m_share_in /* SERVICE_MEM_KIO */
+	protocol:
+		[/uspace/lib/libc/protocol]
+};
Index: contrib/arch/uspace/lib/libc/bind
===================================================================
--- contrib/arch/uspace/lib/libc/bind	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ contrib/arch/uspace/lib/libc/bind	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -1,4 +1,4 @@
 /* Bind %% to kernel interfaces */
-bind %%:sys_klog to kernel:sys_klog;
+bind %%:sys_kio to kernel:sys_kio;
 bind %%:sys_tls to kernel:sys_tls;
 bind %%:sys_thread to kernel:sys_thread;
Index: contrib/arch/uspace/lib/libc/protocol
===================================================================
--- contrib/arch/uspace/lib/libc/protocol	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ contrib/arch/uspace/lib/libc/protocol	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -1,5 +1,5 @@
 /* Protocol according to which libc uses kernel syscalls */
 (
-	!sys_klog.sys_klog +
+	!sys_kio.sys_kio +
 	!sys_tls.sys_tls_set +
 	!sys_thread.sys_thread_create +
Index: contrib/arch/uspace/lib/libc/requires
===================================================================
--- contrib/arch/uspace/lib/libc/requires	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ contrib/arch/uspace/lib/libc/requires	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -1,4 +1,4 @@
 /* Kernel interfaces required by libc */
-sys_klog sys_klog;
+sys_kio sys_kio;
 sys_tls sys_tls;
 sys_thread sys_thread;
Index: contrib/arch/uspace/lib/libc/subsume
===================================================================
--- contrib/arch/uspace/lib/libc/subsume	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ contrib/arch/uspace/lib/libc/subsume	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -1,4 +1,4 @@
 /* Subsume %% to kernel interfaces */
-subsume %%:sys_klog to sys_klog;
+subsume %%:sys_kio to sys_kio;
 subsume %%:sys_tls to sys_tls;
 subsume %%:sys_thread to sys_thread;
Index: contrib/arch/uspace/srv/ns/ns.adl
===================================================================
--- contrib/arch/uspace/srv/ns/ns.adl	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ contrib/arch/uspace/srv/ns/ns.adl	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -6,5 +6,5 @@
 		sysarg_t ipc_m_connect_me_to(in sysarg_t service, in sysarg_t arg2, in sysarg_t arg3, in sysarg_t flags);
 		
-		/* Share real-time clock page or klog page */
+		/* Share real-time clock page or kio page */
 		sysarg_t ipc_m_share_in(in sysarg_t as_area_base, in sysarg_t as_area_size, in sysarg_t service);
 		
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/Makefile	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -212,4 +212,5 @@
 	generic/src/debug/debug.c \
 	generic/src/interrupt/interrupt.c \
+	generic/src/log/log.c \
 	generic/src/main/main.c \
 	generic/src/main/kinit.c \
Index: kernel/arch/amd64/src/interrupt.c
===================================================================
--- kernel/arch/amd64/src/interrupt.c	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/arch/amd64/src/interrupt.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -35,4 +35,5 @@
 #include <arch/interrupt.h>
 #include <print.h>
+#include <log.h>
 #include <debug.h>
 #include <panic.h>
@@ -66,16 +67,16 @@
 void istate_decode(istate_t *istate)
 {
-	printf("cs =%0#18" PRIx64 "\trip=%0#18" PRIx64 "\t"
+	log_printf("cs =%0#18" PRIx64 "\trip=%0#18" PRIx64 "\t"
 	    "rfl=%0#18" PRIx64 "\terr=%0#18" PRIx64 "\n",
 	    istate->cs, istate->rip, istate->rflags, istate->error_word);
 	
 	if (istate_from_uspace(istate))
-		printf("ss =%0#18" PRIx64 "\n", istate->ss);
-	
-	printf("rax=%0#18" PRIx64 "\trbx=%0#18" PRIx64 "\t"
+		log_printf("ss =%0#18" PRIx64 "\n", istate->ss);
+	
+	log_printf("rax=%0#18" PRIx64 "\trbx=%0#18" PRIx64 "\t"
 	    "rcx=%0#18" PRIx64 "\trdx=%0#18" PRIx64 "\n",
 	    istate->rax, istate->rbx, istate->rcx, istate->rdx);
 	
-	printf("rsi=%0#18" PRIx64 "\trdi=%0#18" PRIx64 "\t"
+	log_printf("rsi=%0#18" PRIx64 "\trdi=%0#18" PRIx64 "\t"
 	    "rbp=%0#18" PRIx64 "\trsp=%0#18" PRIx64 "\n",
 	    istate->rsi, istate->rdi, istate->rbp,
@@ -83,9 +84,9 @@
 	    (uintptr_t) &istate->rsp);
 	
-	printf("r8 =%0#18" PRIx64 "\tr9 =%0#18" PRIx64 "\t"
+	log_printf("r8 =%0#18" PRIx64 "\tr9 =%0#18" PRIx64 "\t"
 	    "r10=%0#18" PRIx64 "\tr11=%0#18" PRIx64 "\n",
 	    istate->r8, istate->r9, istate->r10, istate->r11);
 	
-	printf("r12=%0#18" PRIx64 "\tr13=%0#18" PRIx64 "\t"
+	log_printf("r12=%0#18" PRIx64 "\tr13=%0#18" PRIx64 "\t"
 	    "r14=%0#18" PRIx64 "\tr15=%0#18" PRIx64 "\n",
 	    istate->r12, istate->r13, istate->r14, istate->r15);
@@ -193,5 +194,6 @@
 		 */
 #ifdef CONFIG_DEBUG
-		printf("cpu%u: spurious interrupt (inum=%u)\n", CPU->id, inum);
+		log(LF_ARCH, LVL_DEBUG, "cpu%u: spurious interrupt (inum=%u)",
+		    CPU->id, inum);
 #endif
 	}
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/arch/arm32/Makefile.inc	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -89,4 +89,8 @@
 endif
 
+ifeq ($(MACHINE),raspberrypi)
+	ARCH_SOURCES += arch/$(KARCH)/src/mach/raspberrypi/raspberrypi.c
+endif
+
 ifeq ($(CONFIG_PL050),y)
 	ARCH_SOURCES += genarch/src/drivers/pl050/pl050.c
Index: kernel/arch/arm32/_link.ld.in
===================================================================
--- kernel/arch/arm32/_link.ld.in	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/arch/arm32/_link.ld.in	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -13,4 +13,6 @@
 #elif defined MACHINE_beaglebone
 #define KERNEL_LOAD_ADDRESS 0x80a00000
+#elif defined MACHINE_raspberrypi
+#define KERNEL_LOAD_ADDRESS 0x80a08000
 #else
 #define KERNEL_LOAD_ADDRESS 0x80a00000
Index: kernel/arch/arm32/include/arch/cp15.h
===================================================================
--- kernel/arch/arm32/include/arch/cp15.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/arch/arm32/include/arch/cp15.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -231,4 +231,5 @@
 	SCTLR_FAST_IRQ_EN_FLAG       = 1 << 21, /* Disable impl. specific feat*/
 	SCTLR_UNALIGNED_EN_FLAG      = 1 << 22, /* Must be 1 on armv7 */
+	SCTLR_EXTENDED_PT_EN_FLAG    = 1 << 23,
 	SCTLR_IRQ_VECTORS_EN_FLAG    = 1 << 24,
 	SCTLR_BIG_ENDIAN_EXC_FLAG    = 1 << 25,
Index: kernel/arch/arm32/include/arch/mach/integratorcp/integratorcp.h
===================================================================
--- kernel/arch/arm32/include/arch/mach/integratorcp/integratorcp.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/arch/arm32/include/arch/mach/integratorcp/integratorcp.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -46,5 +46,6 @@
 #define ICP_IRQC_MAX_IRQ  8
 #define ICP_KBD_IRQ       3
-#define ICP_TIMER_IRQ    6
+#define ICP_TIMER_IRQ     6
+#define ICP_UART0_IRQ     1
 
 /** Timer frequency */
Index: kernel/arch/arm32/include/arch/mach/raspberrypi/raspberrypi.h
===================================================================
--- kernel/arch/arm32/include/arch/mach/raspberrypi/raspberrypi.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
+++ kernel/arch/arm32/include/arch/mach/raspberrypi/raspberrypi.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -0,0 +1,50 @@
+/*
+ * Copyright (c) 2013 Beniamino Galvani
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup arm32raspberrypi raspberrypi
+ *  @brief Raspberry Pi platform.
+ *  @ingroup arm32
+ * @{
+ */
+/** @file
+ *  @brief Raspberry Pi platform driver.
+ */
+
+#ifndef KERN_arm32_raspberrypi_H_
+#define KERN_arm32_raspberrypi_H_
+
+#include <arch/machine_func.h>
+
+extern struct arm_machine_ops raspberrypi_machine_ops;
+
+#define BCM2835_UART0_BASE_ADDRESS   0x20201000
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/arm32/include/arch/mm/frame.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/frame.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/arch/arm32/include/arch/mm/frame.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -63,4 +63,9 @@
 #define BOOT_PAGE_TABLE_ADDRESS  0x80008000
 
+#elif defined MACHINE_raspberrypi
+
+#define PHYSMEM_START_ADDR       0x00000000
+#define BOOT_PAGE_TABLE_ADDRESS  0x00010000
+
 #else
 
Index: kernel/arch/arm32/include/arch/mm/page_armv6.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page_armv6.h	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/arch/arm32/include/arch/mm/page_armv6.h	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -278,7 +278,12 @@
 	}
 	
+#if defined(PROCESSOR_ARCH_armv6)
+	/* FIXME: this disables caches */
+	p->shareable = 1;
+#else
 	/* Shareable is ignored for devices (non-cacheable),
 	 * turn it off for normal memory. */
 	p->shareable = 0;
+#endif
 	
 	p->non_global = !(flags & PAGE_GLOBAL);
Index: kernel/arch/arm32/src/mach/gta02/gta02.c
===================================================================
--- kernel/arch/arm32/src/mach/gta02/gta02.c	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/arch/arm32/src/mach/gta02/gta02.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -49,4 +49,5 @@
 #include <ddi/ddi.h>
 #include <ddi/device.h>
+#include <log.h>
 
 #define GTA02_MEMORY_START	0x30000000	/* physical */
@@ -149,5 +150,5 @@
 	} else {
 		/* Spurious interrupt.*/
-		printf("cpu%d: spurious interrupt (inum=%d)\n",
+		log(LF_ARCH, LVL_DEBUG, "cpu%d: spurious interrupt (inum=%d)",
 		    CPU->id, inum);
 	}
Index: kernel/arch/arm32/src/mach/integratorcp/integratorcp.c
===================================================================
--- kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision fddffb2826e5c2083834d6285660d19d7b748821)
+++ kernel/arch/arm32/src/mach/integratorcp/integratorcp.c	(revision 19b3cc6e811d9121b454895875bdd47387821c1e)
@@ -37,11 +37,10 @@
 #include <ipc/irq.h>
 #include <console/chardev.h>
+#include <genarch/drivers/pl011/pl011.h>
 #include <genarch/drivers/pl050/pl050.h>
-#include <genarch/drivers/arm926_uart/arm926_uart.h>
 #include <genarch/kbrd/kbrd.h>
 #include <genarch/srln/srln.h>
 #include <console/console.h>
 #include <sysinfo/sysinfo.h>
-#include <print.h>
 #include <ddi/device.h>
 #include <mm/page.h>
@@ -53,5 +52,6 @@
 #include <abi/fb/visuals.h>
 #include <ddi/ddi.h>
-#include <print.h>
+#include <log.h>
+
 
 
@@ -61,5 +61,5 @@
 	icp_hw_map_t hw_map;
 	irq_t timer_irq;
-	arm926_uart_t uart;
+	pl011_uart_t uart;
 } icp;
 
@@ -275,5 +275,6 @@
 			} else {
 				/* Spurious interrupt.*/
-				printf("cpu%d: spurious interrupt (inum=%d)\n",
+				log(LF_ARCH, LVL_DEBUG,
+				    "cpu%d: spurious interrupt (inum=%d)",
 				    CPU->id, i);
 			}
@@ -314,7 +315,6 @@
 		stdout_wire(fbdev);
 #endif
-#ifdef CONFIG_ARM926_UART
-	if (arm926_uart_init(&icp.uart, ARM926_UART0_IRQ,
-	    ARM926_UART0_BASE_ADDRESS, sizeof(arm926_uart_regs_t)))
+#ifdef CONFIG_PL011_UART
+	if (pl011_uart_init(&icp.uart, ICP_UART0_IRQ, ICP_UART))
 		stdout_wire(&icp.uart.outdev);
 #endif
@@ -350,11 +350,11 @@
 	    ICP_KBD);
 
-#ifdef CONFIG_ARM926_UART
+#ifdef CONFIG_PL011_UART
         srln_instance_t *srln_instance = srln_init();
         if (srln_instance) {
                 indev_t *sink = stdin_wire();
                 indev_t *srln = srln_wire(srln_instance, sink);
-                arm926_uart_input_wire(&icp.uart, srln);
-		icp_irqc_unmask(ARM926_UART0_IRQ);
+                pl011_uart_input_wire(&icp.uart, srln);
+                icp_irqc_unmask(ICP_UART0_IRQ);
         }
 #endif
